# coding: utf-8

"""
    Deci Platform API

    Train, deploy, optimize and serve your models using Deci's platform, in your cloud or on premise.  # noqa: E501

    The version of the OpenAPI document: 4.0.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from deci_platform_client import schemas  # noqa: F401


class ModelRequestEvent(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    A base class for all of Deci's model classes.
A model stores data in constant fields, and let us manipulate the data in a more readable way.
    """


    class MetaOapg:
        required = {
            "task",
            "hardware",
        }
        
        class properties:
        
            @staticmethod
            def task() -> typing.Type['DeepLearningTask']:
                return DeepLearningTask
            hardware = schemas.StrSchema
            
            
            class batchSize(
                schemas.ComposedSchema,
            ):
            
            
                class MetaOapg:
                    
                    @classmethod
                    @functools.lru_cache()
                    def any_of(cls):
                        # we need this here to make our import statements work
                        # we must store _composed_schemas in here so the code is only run
                        # when we invoke this method. If we kept this at the class
                        # level we would get an error because the class level
                        # code would be run when this module is imported, and these composed
                        # classes don't exist yet because their module has not finished
                        # loading
                        return [
                            BatchSize,
                            BatchSizeEdge,
                        ]
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                    **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
                ) -> 'batchSize':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                        **kwargs,
                    )
            
            
            class kpis(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['KPI']:
                        return KPI
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['KPI'], typing.List['KPI']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'kpis':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'KPI':
                    return super().__getitem__(i)
            __annotations__ = {
                "task": task,
                "hardware": hardware,
                "batchSize": batchSize,
                "kpis": kpis,
            }
    
    task: 'DeepLearningTask'
    hardware: MetaOapg.properties.hardware
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["task"]) -> 'DeepLearningTask': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["hardware"]) -> MetaOapg.properties.hardware: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["batchSize"]) -> MetaOapg.properties.batchSize: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["kpis"]) -> MetaOapg.properties.kpis: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["task", "hardware", "batchSize", "kpis", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["task"]) -> 'DeepLearningTask': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["hardware"]) -> MetaOapg.properties.hardware: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["batchSize"]) -> typing.Union[MetaOapg.properties.batchSize, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["kpis"]) -> typing.Union[MetaOapg.properties.kpis, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["task", "hardware", "batchSize", "kpis", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        task: 'DeepLearningTask',
        hardware: typing.Union[MetaOapg.properties.hardware, str, ],
        batchSize: typing.Union[MetaOapg.properties.batchSize, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, schemas.Unset] = schemas.unset,
        kpis: typing.Union[MetaOapg.properties.kpis, list, tuple, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'ModelRequestEvent':
        return super().__new__(
            cls,
            *_args,
            task=task,
            hardware=hardware,
            batchSize=batchSize,
            kpis=kpis,
            _configuration=_configuration,
            **kwargs,
        )

from deci_platform_client.model.batch_size import BatchSize
from deci_platform_client.model.batch_size_edge import BatchSizeEdge
from deci_platform_client.model.deep_learning_task import DeepLearningTask
from deci_platform_client.model.kpi import KPI
